/*
 * Copyright (c) 2002 Ian Dowse.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $FreeBSD$
 */

#ifndef _SWAPFS_UTIL_H
#define _SWAPFS_UTIL_H

#define FSORDER_HOST	0
#define FSORDER_SWAP	1
#define FSORDER(order)	((((order) == FSORDER_HOST) ^ \
    (BYTE_ORDER == LITTLE_ENDIAN)) ? "big endian" : "little endian")

void swapfs_sb(struct fs *fs, void *buf, int buflen);
void swapfs_csum(struct fs *fs, struct csum *csum);
void swapfs_cg(struct fs *fs, struct cg *cg, void *buf, int buflen);
void swapfs_dinode(struct fs *fs, struct dinode *dip);
void swapfs_indir(struct fs *fs, void *buf, int buflen);
void swapfs_dir(struct fs *fs, void *hobuf, void *buf, int buflen);

u_int16_t bswap16(u_int16_t x);
u_int32_t bswap32(u_int32_t x);
u_int64_t bswap64(u_int64_t x);

#endif
